#ifndef SAMBLOCK692427728_H
#define SAMBLOCK692427728_H

#include "sim_common_definitions.h"

//BLOCK_PREPROC_DEFS_HERE

class SHARED_LIB_TYPE SamBlock692427728
{
public:
	SamBlock692427728();
	~SamBlock692427728();
	void Initialize(const volatile BLOCK_CONSTRUCTOR_PARAM_STRUCT *arg);
	void* AllocPortMemory(int port_idx, int size);
	void PreRun(const volatile GLOBAL_PRERUN_PARAM_STRUCT *arg, _FXDPT_FLOAT *in1, _FXDPT_FLOAT *in2, _FXDPT_FLOAT *o1);
	void Run(const volatile GLOBAL_RUN_PARAM_STRUCT *arg, _FXDPT_FLOAT *in1, _FXDPT_FLOAT *in2, _FXDPT_FLOAT *o1);
	void RunPlotStep(const volatile GLOBAL_RUN_PARAM_STRUCT *arg, _FXDPT_FLOAT *in1, _FXDPT_FLOAT *in2, _FXDPT_FLOAT *o1);
	void PostRun(const volatile GLOBAL_POSTRUN_PARAM_STRUCT *arg, _FXDPT_FLOAT *in1, _FXDPT_FLOAT *in2, _FXDPT_FLOAT *o1);
	/*
	void ElInit(volatile SIM_PHY_EN_STRUCT *entities, int en_idx, int index);
	void CalG(volatile SIM_PHY_EN_STRUCT *entities, const volatile GLOBAL_RUN_PARAM_STRUCT *arg, _FXDPT_FLOAT h, _FXDPT_FLOAT *in1, _FXDPT_FLOAT *in2, _FXDPT_FLOAT *o1);
	void CalI(volatile SIM_PHY_EN_STRUCT *entities, const volatile GLOBAL_RUN_PARAM_STRUCT *arg, _FXDPT_FLOAT h, _FXDPT_FLOAT *in1, _FXDPT_FLOAT *in2, _FXDPT_FLOAT *o1);
#ifndef _BUILD_ARCH_FPGA
	static void CalG_Batch(SamBlock692427728 **obj, int nobjs, volatile SIM_PHY_EN_STRUCT *entities, const volatile GLOBAL_RUN_PARAM_STRUCT *arg, _FXDPT_FLOAT h);
	static void CalI_Batch(SamBlock692427728 **obj, int nobjs, volatile SIM_PHY_EN_STRUCT *entities, const volatile GLOBAL_RUN_PARAM_STRUCT *arg, _FXDPT_FLOAT h);
#endif
	*/
public:
#ifdef _BUILD_ARCH_OS
	//void (SamBlock692427728::*PtrToRun)(const volatile GLOBAL_RUN_PARAM_STRUCT*, _FXDPT_FLOAT*, _FXDPT_FLOAT*, _FXDPT_FLOAT*);
	//void (SamBlock692427728::*PtrToRunPlotStep)(const volatile GLOBAL_RUN_PARAM_STRUCT*, _FXDPT_FLOAT*, _FXDPT_FLOAT*, _FXDPT_FLOAT*);
#endif
	//char* _dependent_obj;
	//char m_blk_path[SIM_BLK_PATH_MAX_SIZE];
	//port variable declaration
#ifndef _BUILD_ARCH_FPGA
	_FXDPT_FLOAT *m_in1;
	_FXDPT_FLOAT *m_in2;
	_FXDPT_FLOAT *m_o1;
#endif
	//block internal parameter variable declaration
	_INT32 port_size;
        _BYTE op_type;
	//block internal initial condition variable declaration
private:
	_BYTE m_prerun_count;
	//_UINT32 m_blk_id;
};

#endif
